<template>
    <div>
        <b-modal v-model="checkoutError" hide-header ok-only centered>
            {{ error }}
        </b-modal>

        <b-modal centered
            hide-header
            hide-footer
            no-close-on-backdrop
            no-close-on-esc
            v-model="proceedingToCheckout">

            <p class="mb-0">Serás redireccionado a Mercado Pago en unos instantes...</p>
        </b-modal>

        <b-button v-if="product.stock > 0" 
            @click="proceedToCheckout()" 
            name="MP-Checkout" :id="`buy-cta-${product.id}`" 
            block 
            :size="size">
            <fa-icon icon="shopping-cart" /> Comprar
        </b-button>
        <b-badge v-else variant="danger">Sin stock</b-badge>
    </div>
</template>

<style lang="scss" scoped>
    .btn {
        border-color: black;
        background-color: transparent;
        color: black;
        &:active {
            background-color: transparent !important;
        }
        &:focus {
            box-shadow: none;
        }
        &.active:focus {
            box-shadow: none;
            color: black;
        }
    }
</style>

<script>
    import { BModal, BButton, BBadge } from 'bootstrap-vue'
    import { library } from '@fortawesome/fontawesome-svg-core'
    import { faShoppingCart } from '@fortawesome/free-solid-svg-icons'
    import { FontAwesomeIcon } from '@fortawesome/vue-fontawesome'

    library.add([faShoppingCart])

    export default {
        components: {
            'b-modal': BModal,
            'b-button': BButton,
            'b-badge': BBadge,
            'fa-icon': FontAwesomeIcon
        },
        props: {
            product: {
                type: Object,
                required: true
            },
            size: {
                type: String,
                required: false
            }
        },
        data() {
            return {
                proceedingToCheckout: false,
                checkoutError: false,
                error: null
            };
        },
        methods: {
            proceedToCheckout() {
                this.proceedingToCheckout = true;
                this.$http.post('/api/checkout', {productId: this.product.id})
                    .then(response => {
                        window.location.href = response.body.data.checkoutUrl;
                    }, response =>  {
                        this.checkoutError = true;
                        this.error = response.body.error || 'Ha ocurrido un error inesperado';
                        this.proceedingToCheckout = false;
                        if (response.status == 488) {
                            this.product.stock = 0;
                        }
                    });
            }
        },
        created() {
            if (! this.size) {
                this.size = 'md';
            }
        }        
    }
</script>
